#if !defined  HAVE_CAYLEY_DICKSON_ZD_H__
#define       HAVE_CAYLEY_DICKSON_ZD_H__
// This file is part of the FXT library.
// Copyright (C) 2011 Joerg Arndt
// License: GNU General Public License version 3 or later,
// see the file COPYING.txt in the main directory.

#include "aux0/swap.h"
#include "bits/bithigh.h"
#include "fxttypes.h"

inline bool CD_szdq(ulong r, ulong c)
// Return whether (r+c) where r and c are units
// is a zero divisor in the Cayley-Dickson algebra.
{
 start:
    if ( (r<8) && (c<8) )  return false;
    if ( c>r )  swap2(r, c);
    // r>=c
    const ulong h = highest_one(r);
    if( (r^c) & h )  // lower left or upper right
    {
        r &= ~h;
        if ( r==c )  return  false;
        if ( c==0 )  return  false;
        if ( r==0 )  return  false;
        return true;
    }
    // move to upper left:
    r &= ~h;
    c &= ~h;
    goto start;
}
// -------------------------

#endif  // !defined HAVE_CAYLEY_DICKSON_ZD_H__
